;tests all possible ports from 0x210 - 0x220
; w 1 > 0x2x6
; r   < 0x2x6 (4 times)
; w 0 > 0x2x6
; r   < 0x2xA (100 times, some cards are slow)
;	should be 0xAA, otherwise card is not found
; next port

code segment
org 100h
assume cs:code,ds:code
start: jmp debut

include affhex.asm
include affich.asm

debut:
mov dx,210h
tsp0:
add dx,6
mov al,1
out dx,al;      reset DSP

in al,dx
in al,dx
in al,dx
in al,dx

mov al,0
out dx,al
add dx,4 ;      dx = dsp read port
mov cx,100 ; 	test card presence 100 times
tsp1:
in al,dx
cmp al,0aah
je tstr ;       card found
loop tsp1
sub dx,10 ; 	dx= base port
cmp dx,270h ; 	last ?
je tsf ;        not found
add dx,10h ;	next
jmp tsp0
tsf:
mov dx,offset ntrv
call affich
jmp fin
tstr:
sub dx,10
mov word ptr sbadr,dx
mov dx,offset trv
call affich
mov ax,word ptr sbadr
mov si,offset adr
call affhex
mov dx,offset adr
call affich
fin:
mov ax,4c00h
int 21h
trv  db 'SB 16 detected at adress ','$'
ntrv db 'SB 16 not found','$'
adr db 10 dup (?)
sbadr dw 0
code ends
end start
